<template>
  <div class="feedback">
    <div class="feedback-wrapper">
      <header class="feedback-header">
        <div class="feedback-user">
          <div
            class="feedback-user-avatar"
            :class="`_color${randomInteger(1, 3)}`">
            <span>{{ nameAbbreviation }}</span>
          </div>
          <div class="feedback-user-meta">
            <span class="feedback-user-name">
              {{ feedback.senderUserName }}
            </span>
            <div class="feedback-user-rating">
              <AppRating
                :current-rating="feedback.rating"
                :size="12"/>
              <span class="count">{{ feedback.rating }}</span>
            </div>
          </div>
        </div>
        <AppPopover
          v-if="!authUser"
          class="feedback-options"
          :options="popoverOptions">
          <template
            slot="tooltip-trigger">
            <div class="likeCounter">
              <AppButton
                :classes="['buttonLike']"
                @click.native="onClick">
                <span
                  slot="button-item"
                  class="button-item">
                  <img
                    svg-inline
                    src="~/assets/svg/redesign/like.svg">
                </span>
              </AppButton>
              <div class="likeCounter-value">
                {{ feedback.likersCount || 0 }}
              </div>
            </div>
          </template>
          <template
            slot="tooltip-content">
            <div class="tooltip-text">Доступно только авторизованным</div>
            <AppButton
              v-if="!$slots['entry-item'] || authUser"
              :classes="['userActionsTrigger', 'buttonOutline']"
              v-close-popover
              @click.native="onLogin">
              <span
                slot="button-item"
                class="button-item">
                <span class="user-text">
                  {{ (authUser && authUser.username) || 'Войти или зарегистрироваться' }}
                </span>
              </span>
            </AppButton>
          </template>
        </AppPopover>
        <div
          class="likeCounter"
          v-if="authUser">
          <AppButton
            :classes="['buttonLike']"
            @click.native="onClick">
            <span
              slot="button-item"
              class="button-item">
              <img
                svg-inline
                src="~/assets/svg/redesign/like.svg">
            </span>
          </AppButton>
          <div class="likeCounter-value">
            {{ feedback.likersCount || 0 }}
          </div>
        </div>
      </header>
      <div class="feedback-text">
        {{ feedback.senderComment }}
      </div>
      <footer class="feedback-footer">
        <div class="feedback-date">
          <!--<img
            svg-inline
            src="~/assets/svg/redesign/clip.svg">-->
          <span>{{ feedback.createdAt | dateFormat({ time: true }) }}</span>
        </div>
      </footer>
    </div>
  </div>
</template>

<script>
import AppButton from '~/components/redesign/app-buttons/app-button';
import AppPopover from '~/components/redesign/app-tooltip/app-popover';
import AppRating from '~/components/redesign/app-rating';

export default {
  name: 'Feedback',
  components: {
    AppButton,
    AppRating,
    AppPopover,
  },
  props: {
    feedback: {
      type: Object,
      default() { return {}; },
    },
    authUser: {
      type: Object,
      default() { return {}; },
    },
    isSameUser: {
      type: Boolean,
      default: false,
    },
  },
  computed: {
    nameAbbreviation() {
      return this.feedback.senderUserName
        .split(' ')
        .reduce((acc, entry) => acc.concat(entry[0]), [])
        .join('');
    },
    popoverOptions() {
      return {
        trigger: 'click',
        enabled: Boolean(this.auth),
        additionalClasses: ['tooltipFeedback', 'tooltipDark'],
        autoHide: true,
      };
    },
  },
  methods: {
    randomInteger(min, max) {
      return Math.round(min + Math.random() * (max - min));
    },
    onClick() {
      this.$emit('add-like', this.feedback.id);
    },
    onLogin() {
      if (!this.auth) {
        this.$emit('login');
      }
    },
  },
};
</script>

<style lang="postcss">
  .feedback {
    &-header {
      display: flex;
      align-items: flex-start;
    }

    &-user {
      display: flex;
      width: 100%;

      &-name {
        display: block;
        padding-bottom: 0.25rem;
        font-size: 0.875rem;
        font-weight: var(--font-weight-medium);
      }

      &-rating {
        display: flex;
        font-size: 0.75rem;
        color: var(--color-main-lightest);

        > .count {
          display: inline-block;
          padding-left: 0.25rem;
        }
      }

      &-avatar {
        display: flex;
        justify-content: center;
        align-items: center;
        margin-right: 1rem;
        width: 2.5rem;
        height: 2.5rem;
        border-radius: 50%;

        &._color1 {
          color: var(--color-yellow);
          background-color: var(--feedback-bg-yellow);
        }

        &._color2 {
          color: var(--color-green);
          background-color: var(--feedback-bg-green);
        }

        &._color3 {
          color: var(--color-red);
          background-color: var(--feedback-bg-red);
        }
      }
    }

    &-text {
      display: block;
      padding: 0.5rem 0 0.5rem 3.5rem;
      font-size: 0.875rem;
    }

    &-footer {
      display: block;
      padding: 0.5rem 0 0.5rem 3.5rem;
    }

    &-date {
      display: flex;
      align-items: center;
      font-size: 0.75rem;
      color: var(--color-main-lightest);

      .svg {
        margin-right: 0.5rem;
        fill: var(--fill-hover);
      }
    }

    & .likeCounter {
      display: flex;

      & .likeCounter-value {
        display: inline-flex;
        padding-top: 0.25rem;
        padding-left: 0.5rem;
        font-size: 0.75rem;
        line-height: 1;
        color: var(--color-main-lightest);
      }
    }

    @media screen and (max-width: 980px) {
      &-user {
        &-name {
          padding-bottom: 0.5rem;
        }
        &-avatar {
          margin-right: 0.75rem;
        }
      }

      & .likeCounter {
        align-items: center;
        & .likeCounter-value {
          font-size: 1rem;
          color: var(--color-green);
        }
      }
    }
  }

</style>
